//+------------------------------------------------------------------+
//|                                Indicator: SVE  RSI Arrows v5.mq4 |
//|                                       Created with EABuilder.co |
//|                                             http://eabuilder.co |
//+------------------------------------------------------------------+
#property copyright "Created using FREE Indicators Builder"
#property link      "http://eabuilder.co"
#property copyright "Arrows for SVE RSI Developed by"
#property link      "http://www.binaryeasy.club"
#property version   "5.00"
#property description "V5 ChangeLog:"
#property description "+ Taken off VC filter. It didnt work well with SVE."
#property description "+ SVE Values updated trigger trade on:"
#property description "Cross above 11 = CALL"
#property description "Cross  Below 87 = PUT"

//#include <stdlib.mqh>
//#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 1
#property indicator_color1 0xFFAA00
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 1
#property indicator_color2 0x0000FF
#property indicator_label2 "PUT"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

extern double ValueChart_Below = -6;
extern double ValueChart_Above = 6;
extern double SVE_Cross_Above_CALL = 11;
extern double SVE_Cross_Below_PUT = 87;
datetime time_alert; //used when sending alert
extern bool Send_Email = true;
extern bool Audible_Alerts = true;
double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | SVE  RSI Arrows v5 @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
   else if(type == "indicator")
     {
      Print(type+" | SVE  RSI Arrows v5 @ "+Symbol()+","+Period()+" | "+message);
      if(Audible_Alerts) Alert(type+" | SVE  RSI Arrows v5 @ "+Symbol()+","+Period()+" | "+message);
      if(Send_Email) SendMail("SVE  RSI Arrows v5", type+" | SVE  RSI Arrows v5 @ "+Symbol()+","+Period()+" | "+message);
      SendNotification(type+" | SVE  RSI Arrows v5 @ "+Symbol()+","+Period()+" | "+message);
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, 0);
   SetIndexArrow(0, 241);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, 0);
   SetIndexArrow(1, 242);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      //Indicator Buffer 1
      if(iCustom(NULL, PERIOD_CURRENT, "SVE_RSI_I-Fish", 4, 4, 1, 12, 88, false, "", 500, 0, i) > SVE_Cross_Above_CALL
      && iCustom(NULL, PERIOD_CURRENT, "SVE_RSI_I-Fish", 4, 4, 1, 12, 88, false, "", 500, 0, i+1) < SVE_Cross_Above_CALL //SVE_RSI_I-Fish crosses above fixed value
      )
        {
         Buffer1[i] = Low[i]; //Set indicator value at Candlestick Low
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "Buy"); time_alert = Time[0]; } //Instant alert, only once per bar
        }
      //Indicator Buffer 2
      if(iCustom(NULL, PERIOD_CURRENT, "SVE_RSI_I-Fish", 4, 4, 1, 12, 88, false, "", 500, 0, i) < SVE_Cross_Below_PUT
      && iCustom(NULL, PERIOD_CURRENT, "SVE_RSI_I-Fish", 4, 4, 1, 12, 88, false, "", 500, 0, i+1) > SVE_Cross_Below_PUT //SVE_RSI_I-Fish crosses below fixed value
      )
        {
         Buffer2[i] = High[i]; //Set indicator value at Candlestick High
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "PUT"); time_alert = Time[0]; } //Instant alert, only once per bar
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+